<?xml version="1.0" encoding="UTF-8"?>
<!--
 * Scilab ( https://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) INRIA
 * Copyright (C) 2012 - 2016 - Scilab Enterprises
 * Copyright (C) 2016 - Scilab Enterprises - Pierre-Aimé AGNEL
 * Copyright (C) 2019 - Samuel GOUGEON
 *
 * This file is hereby licensed under the terms of the GNU GPL v2.0,
 * pursuant to article 5.3.4 of the CeCILL v.2.1.
 * This file was originally licensed under the terms of the CeCILL v2.1,
 * and continues to be available under such terms.
 * For more information, see the COPYING file which you should have received
 * along with this program.
 *
 -->
<refentry xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg" xmlns:ns5="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML" xmlns:db="http://docbook.org/ns/docbook"
          xmlns:scilab="http://www.scilab.org" xml:id="tbx_make" xml:lang="en">

    <refnamediv>
        <refname>tbx_make</refname>
        <refpurpose>
            Builds a toolbox having a standard structure (EXPERIMENTAL)
        </refpurpose>
    </refnamediv>

    <refsynopsisdiv>
        <title>Syntax</title>
        <synopsis>
            tbx_make()
            tbx_make(tbx_path)
            tbx_make(tbx_path, sections)
        </synopsis>
    </refsynopsisdiv>

    <refsection role="parameters">
        <title>Arguments</title>
        <variablelist>
            <varlistentry>
                <term>tbx_path</term>
                <listitem>
                    <para>a single string: absolute or relative path to the toolbox root directory.</para>
                    <para>Default path is the current working directory.</para>
                </listitem>
            </varlistentry>
            <varlistentry>
                <term>sections</term>
                <listitem>
                    <para>
                        matrix of strings: Names of the toolbox sections to be built, amongst
                        <literal>["macros", "help", "src", "sci_gateway", "localization"]</literal>.
                        <literal>"*"</literal> can be used to force building all available
                        sections instead of running the builder script when it exists.
                    </para>
                    <para>
                        Default or <literal>[]</literal> will select all available sections
                        in case of missing builder script.
                    </para>
                </listitem>
            </varlistentry>
        </variablelist>
    </refsection>

    <refsection role="description">
        <title>Description</title>
        <para>
            The short name (id) <literal>tbx_name</literal> of the toolbox is retrieved as the
            basename of the <literal>etc/*.start</literal> file.
            This file is mandatory, even if it is empty.
        </para>
        <para>
            <varname>tbx_make</varname> builds the toolbox pointed to by its root directory
            <varname>tbx_path</varname>, by executing an explicit or default builder script.
        </para>
        <para>

        </para>
        <para>
            If some <varname>sections</varname> are explicitly required to build,
            <literal>tbx_make(..)</literal> runs a default builder for each of them.
        </para>
        <para>
            Otherwise, <literal>tbx_path</literal> is scanned for a script named like
            <literal>build*.sce</literal>.
            <itemizedlist>
                <listitem>
                    If such a file is found, <literal>tbx_make</literal> executes it, and that's it.
                </listitem>
                <listitem>
                    Otherwise, all available toolbox sections are built with the default builders.
                </listitem>
            </itemizedlist>
        </para>
        <para>
            Default builders process the sections of the toolbox according to the following conventions:
        </para>
        <para>
            <informaltable border="1" valign="top">
                <tr>
                    <th>
                        <literal>macros/</literal>
                    </th>
                    <td>
                        All macros files <literal>*.sci</literal> available in the
                        <literal>~/macros/*</literal> directory are compiled and gathered into a
                        library named <literal><emphasis role="bold">tbx_name</emphasis>lib</literal>
                        (Please see <link linkend="tbx_builder_macros">tbx_builder_macros</link>).
                        <para/>
                        Unless there is a custom macros builder script in <literal>~/macros/*</literal>,
                        no automatical recursive processing aiming to build sublibraries in
                        subdirectories is performed.
                    </td>
                </tr>
                <tr>
                    <th>
                        <literal>src/</literal>
                    </th>
                    <td>
                        Functional external code in src is compiled.
                        (Please see <link linkend="tbx_builder_src">tbx_builder_src</link>)
                    </td>
                </tr>
                <tr>
                    <th>
                        <literal>sci_gateway/</literal>
                    </th>
                    <td>
                        gateway functions in sci_gateway are compiled.
                        (Please see <link linkend="tbx_builder_gateway">tbx_builder_gateway</link>)
                    </td>
                </tr>
                <tr>
                    <th>
                        <literal>localization</literal>
                    </th>
                    <td>
                        Localization files are built and/or postprocessed
                        (Please see <link linkend="tbx_build_localization">tbx_build_localization</link>)
                    </td>
                </tr>
                <tr>
                    <th>
                        <literal>help/</literal>
                    </th>
                    <td>
                        Help pages are generated from XML source files stored in
                        <literal>~/help/*</literal> available languages subdirectories
                        (en_US, fr_FR, etc)
                        (Please see <link linkend="tbx_builder_help">tbx_builder_help</link>).
                    </td>
                </tr>
            </informaltable>
        </para>
        <para>
            This default behaviour mimics the <literal>builder.sce</literal> script provided in the
            toolbox_skeleton template module available in <literal>SCI/contrib</literal>.
        </para>
        <para>
            <literal>loader.sce</literal>, <literal>unloader.sce</literal> and <literal>cleaner.sce</literal>
            scripts are always created at the toolbox's root.
        </para>
    </refsection>
    <refsection>
        <title>Examples</title>
        <programlisting role="no-scilab-exec"><![CDATA[
// The working directory is set at the toolbox root:
tbx_make()          // builds the toolbox with the toolbox builder (if any),
                    //  or for all sections with default builders otherwise.
tbx_make .  macros  // builds only its macros section from files in ./macros/
tbx_make .  *       // builds all available sections, without using the toolbox builder

// Builds the toolbox located in path/to/mytoolbox directory
tbx_make("path/to/mytoolbox")

// Compiles macros help and src for the toolbox located in path/to/mytoolbox
tbx_make("path/to/mytoolbox", ["macros", "help", "src"])
]]></programlisting>
    </refsection>

    <refsection role="see also">
        <title>See Also</title>
        <simplelist type="inline">
            <member>
                <link linkend="tbx_builder_macros">tbx_builder_macros</link>
            </member>
            <member>
                <link linkend="tbx_builder_help">tbx_builder_help</link>
            </member>
            <member>
                <link linkend="tbx_build_localization">tbx_build_localization</link>
            </member>
            <member>
                <link linkend="tbx_builder_src">tbx_builder_src</link>
            </member>
            <member>
                <link linkend="tbx_builder_gateway">tbx_builder_gateway</link>
            </member>
            <member>
                <link linkend="tbx_build_blocks">tbx_build_blocks</link>
            </member>
            <member>
                <link linkend="tbx_build_loader">tbx_build_loader</link>
            </member>
            <member>
                <link linkend="tbx_build_cleaner">tbx_build_cleaner</link>
            </member>
        </simplelist>
    </refsection>

    <refsection role="history">
        <title>History</title>
        <revhistory>
            <revision>
                <revnumber>6.0.0</revnumber>
                <revremark>
                    <literal>tbx_make()</literal> introduced.
                </revremark>
            </revision>
            <revision>
                <revnumber>6.0.1</revnumber>
                <revremark>
                    The existing builder is run only if no specific sections are requested.
                </revremark>
            </revision>
        </revhistory>
    </refsection>
</refentry>
